import random
import string


def get_sum(*args):
    return sum(args)










def is_palindrome(data):
    """
    Tests if the argument is a palindrome
    :param data: The string to be tested
    :return: True if the argument is a palindrome, False otherwise

    >>> is_palindrome('Hello world.')
    False

    >>> is_palindrome('Too far Edna we wander afoot')
    True
    """
    return data.replace(' ', '').lower() == data[::-1].replace(' ', '').lower()


def generate_passwd(length=10, special=5):
    """
    Generates a random string (password). The "random.randint()" is not used here.
    :param length: The total length of the password
    :param special: The number of special characters that are generated in the password
    :return: The generated password
    """
    passwd = str()

    i = 0
    while i < length - special:
        passwd += random.choice(string.ascii_letters)
        i += 1

    i = 0
    while i < special:
        idx = random.randint(0, len(passwd))
        passwd = passwd[:idx] + random.choice(string.punctuation) + passwd[idx:]
        i += 1

    return passwd


def my_map(data, function):
    return [function(item) for item in data]

def fibo_gen(n):
    fib1 = 1
    fib2 = 1

    if n > 0:
        yield 1
    else:
        return

    if n > 1:
        yield 1
    else:
        return
    generated = 2

    while generated < n:
        fib1, fib2 = fib2, fib1 + fib2
        generated += 1
        yield fib2


def my_range(*args):
    if len(args) < 1 or len(args) > 3:
        raise TypeError('Wrong number of arguments')

    if len(args) == 1:
        start = 0
        limit = args[0]
        step = 1
    elif len(args) == 2:
        start = args[0]
        limit = args[1]
        step = 1
    else:
        start = args[0]
        limit = args[1]
        step = args[2]

    if step == 0:
        raise ValueError('my_range() arg 3 must not be zero')

    while start < limit if step > 0 else start > limit:
        yield start
        start += step


def print_files(files):
    """
    Prints the files line by line. The printing is guided by user input (from stdin):
      Enter for another line
      n for the next file
      q for quit
    :param files: The list of files to be printed out
    :return: nothing
    """

    def print_single_file(filename):
        """
        Prints a single file line by line. For more information, see {print_files}.
        :param filename: The filename to be printed
        :return: True if next file should be printed, False if the program should exit
        """
        with open(filename, 'rt') as f:
            while True:
                line = f.readline().strip()  # One usually needs to strip the last newline character.
                if line == '':
                    return True

                print(line, end='')  # end='' is not needed, it depends on how one wants to the output formatted.
                command = input().strip()

                if command == 'q':
                    return False
                elif command == 'n':
                    return True
                else:
                    pass

    for filename in files:
        if not print_single_file(filename):
            break


#print(get_sum(1, 2, 3, 4))

#print(is_palindrome('Devil never even lived'))

#print(generate_passwd(length=15, special=2))

print(my_map(['one', 'two', 'three'], lambda x: x[::-1]))

#for i in fibo_gen(10):
#    print(i)

#for i in my_range(15, 5, -2):
#    print (i)

#print_files(['1234.csv', 'emails.txt', 'emails.yaml'])


